//  yv122nv12.h
//
//	YV12 to NV12 converter
//
//	Copyright (c) 2004
//

//GUID
/* 449cb461-f808-4889-b93e-b12be863266f */
DEFINE_GUID(CLSID_YV122NV12,
	0x449cb461,
    0xf808,
    0x4889,
    0xb9, 0x3e, 0xb1, 0x2b, 0xe8, 0x63, 0x26, 0x6f);

//custom allocater
class Cyv122nv12Allocator : public CMemAllocator
{
private:
	AM_MEDIA_TYPE *pMT;
	BOOL ch;
public:
	Cyv122nv12Allocator(TCHAR *pName, LPUNKNOWN pUnk, HRESULT *phr)
		: CMemAllocator(pName, pUnk, phr)
	{ch = FALSE; pMT = NULL;}
	~Cyv122nv12Allocator(){if(pMT) DeleteMediaType(pMT);}
	HRESULT ChangeMediaType(AM_MEDIA_TYPE *pMediaType);
	HRESULT SetMediaType(AM_MEDIA_TYPE *pMediaType);
	STDMETHODIMP Cyv122nv12Allocator::GetBuffer(IMediaSample **ppBuffer, 
		REFERENCE_TIME *pStartTime, REFERENCE_TIME *pEndTime, DWORD dwFlags);
	STDMETHODIMP SetProperties(ALLOCATOR_PROPERTIES *pRequest, ALLOCATOR_PROPERTIES *pActual);
};

//custom input pin
class Cyv122nv12InputPin : public CTransformInputPin
{
private:
	BOOL CustomAllocater;
public:
	Cyv122nv12InputPin(TCHAR *pObjectName, CTransformFilter *pTransformFilter, HRESULT *phr, LPCWSTR pName) 
		: CTransformInputPin(pObjectName, pTransformFilter, phr, pName) 
	{ CustomAllocater = TRUE; }
	
    STDMETHODIMP GetAllocator(IMemAllocator **ppAllocator);
	STDMETHODIMP NotifyAllocator(IMemAllocator *pAllocator, BOOL bReadOnly);

	HRESULT ChangeMediaType(AM_MEDIA_TYPE *pMediaType)
	{
		return static_cast<Cyv122nv12Allocator*>(m_pAllocator)->ChangeMediaType(pMediaType);
	}
	BOOL UsingCustomAllocater() { return CustomAllocater; }
};

class Cyv122nv12 : public CTransformFilter
{
private:
	LONG hIn;      // ̓C[W̍
	LONG wIn;      // ̓C[W̕(XgChȂ)
	LONG swIn;     // ̓C[W̕(XgCh)
	LONG hOut;     // o̓C[W̍
	LONG wOut;     // o̓C[W̕(XgChȂ)
	LONG swOut;    // o̓C[W̕(XgCh)
	bool mmx;
public:
	DECLARE_IUNKNOWN;
	Cyv122nv12(TCHAR *tszName, LPUNKNOWN punk);
	CBasePin * GetPin(int n);
	HRESULT CheckInputType(const CMediaType *mtIn);
	HRESULT GetMediaType(int iPosition, CMediaType *pMediaType);
	HRESULT CheckTransform(const CMediaType *mtIn, const CMediaType *mtOut);
	HRESULT DecideBufferSize(IMemAllocator *pAlloc, ALLOCATOR_PROPERTIES *pProp);
	HRESULT Transform(IMediaSample *pSource, IMediaSample *pDest);
	static CUnknown * WINAPI CreateInstance(LPUNKNOWN pUnk, HRESULT *pHr);
};

REGPINTYPES sudInputTypes = { &MEDIATYPE_Video, &MEDIASUBTYPE_YV12 };
REGPINTYPES sudOutputTypes = { &MEDIATYPE_Video, &MEDIASUBTYPE_NV12 };

// s錾B
REGFILTERPINS sudPinReg[] = {
    // ̓sB
    { 0, FALSE, // Rendered?
         FALSE, // Output?
         FALSE, // Zero?
         FALSE, // Many?
         0, 0, 
         1, &sudInputTypes  // Media types.
    },
    // o̓sB
    { 0, FALSE, // _OĂ邩?
         TRUE, // o?
         FALSE, // [?
         FALSE, // ?
         0, 0, 
         1, &sudOutputTypes      // fBA ^CvB
    }
};
 
// tB^錾B
REGFILTER2 rf2FilterReg = {
    1,                // o[WԍB
    MERIT_DO_NOT_USE, // bgB
    2,                // s̐B
    sudPinReg         // sւ̃|C^B
};


extern "C"
{
void yv12_2_nv12(BYTE *, BYTE *, LONG, LONG);
void yv12_2_nv12a(BYTE *, BYTE *, LONG, LONG, LONG, LONG);
void mmx_yv12_2_nv12(BYTE *, BYTE *, LONG, LONG);
void mmx_yv12_2_nv12a(BYTE *, BYTE *, LONG, LONG, LONG, LONG);
}

//tB^
static WCHAR g_wszName[] = L"YV12 to NV12 converter";

CFactoryTemplate g_Templates[] = 
{
  { 
    g_wszName,
    &CLSID_YV122NV12,
    Cyv122nv12::CreateInstance,
    NULL,
    NULL
  }
};

int g_cTemplates = sizeof(g_Templates) / sizeof(g_Templates[0]);
